Const adSaveCreateNotExist = 1
Const adSaveCreateOverWrite = 2
Const adTypeBinary = 1 'Binary data
Const adTypeText = 2 '(Default) Text data
Const adLF = 10
Const adCR = 13
Const adCRLF = -1

Const adReadLine = -2
Const adWriteChar = 0
Const adWriteLine = 1

'indexes StatData record fields
Const SD_STAT = 0
Const SD_SCRIPT = 1
Const SD_LSTART = 2
Const SD_LEND = 3
Const SD_TYPE = 4
Const SD_USEN = 5
Const SD_RNDTYPE = 6
Const SD_RNDDEC = 7
Const SD_P1 = 8
Const SD_P2 = 9
Const SD_P3 = 10
Const SD_P4 = 11
Const SD_P5 = 12
Const SD_P6 = 13
Const SD_COMPF = 14
Const SDFLDCNT = 15

Const SDFLDSEP = ","
Const SDSTRQUOT = """"

Const InFileName = "statdata.csv"
Const DataFileName = "statdcmp.dat"

'script data
Dim ScriptDescr
Dim OutFileName
Dim STextStart
Dim STextMainStart
Dim STextMainEnd
Dim STextSubStart
Dim STextSubEnd
Dim STextSNSearchSubResult
Dim STextEnd
Dim STextSNSearchCondStartSm
Dim STextSNSearchCondSm
Dim STextSNSearchCondStartEq
Dim STextSNSearchCondEq
Dim STextSNSearchCondStartGr
Dim STextSNSearchCondGr
Dim STextSNSearchAlternative
Dim STextSNSearchEnd
Dim STextSNSearchResult
Dim STextSNSearchResultData
Dim STextSeqLSearchCondStart
Dim STextSeqLSearchCond
Dim STextSeqLSearchAlternative
Dim STextSeqLSearchEnd
Dim STextSeqLSearchResult
Dim STextSeqLSearchResultData
Dim STextIntLSearchCondStart
Dim STextIntLSearchCond
Dim STextIntLSearchAlternative
Dim STextIntLSearchEnd
Dim STextIntLSearchResult
Dim STextIntLSearchResultData
Dim	STextDefineC
Dim	STextDefineL
Dim	STextDefineN
Dim	STextDefinePUNDEF
Dim	STextDefinePNULL
Dim	STextDefineSN
Dim STextArray
Dim STextDefineCastNum

'script text variables
Const STV_SN = "$STATNAME"
Dim STV_SN_TEXT
Const STV_LVL = "$LEVEL"
Dim STV_LVL_TEXT
Const STV_LSTART = "$LVLSTART"
Dim STV_LSTART_TEXT
Const STV_LEND = "$LVLEND"
Dim STV_LEND_TEXT
Const STV_CALC = "$CALC"
Dim STV_CALC_TEXT
Const STV_DATA = "$DATA"
Dim STV_DATA_TEXT
Const STV_NODEID = "$NODEID"
Dim STV_NODEID_TEXT
Const STV_CHILDID = "$CHILDID"
Dim STV_CHILDID_TEXT

'indexes Binary Search Tree node variables
Const BST_KEY = 0
Const BST_VALUE = 1
Const BST_LEFT = 2
Const BST_RIGHT = 3
Const BSTFLDCNT = 4

'scripting types
Const SCRIPT_DEFINE = "D" 'define $name for replacements
Const SCRIPT_SEQUENTIAL = "S" 'in sequence L <= Lend
Const SCRIPT_INTERVAL = "I" 'by interval Lstart <= L <= Lend
Const SCRIPT_REMARK = "R" 'script line for important remarks

'rounding types
Const RND_NORMAL = "N" 'normal rounding up/down
Const RND_UP = "U" 'rounding up
Const RND_DOWN = "D" 'rounding down
Const RND_LOTRO = "L" 'Lotro rounding: rounding up + 3 significant digits

'defines
Const DF_DEF = 0 'define name to replace
Const DF_REPL = 1 'replacement text
Const DF_TYPE = 2 'define type
Const DF_DECIMALS = 3 'optional rounding
'define types
Const DFT_TEXT = 1 'define is type text
Const DFT_EXPR = 2 'define is type expression

Const optCompileFull = 0 'full version with all stats
Const optCompilePercentages = 1 'percentage calculations only
Const optCompileTraitTrees = 2 'trait trees stats

Dim CompileOption 'compile option choice

Main
Sub Main

	SetLocale("en-us")

	Dim DataArray

	If Not ReadDataFile(DataFileName,DataArray) Then
		MsgBox Replace("Could not read #S# file. Operation cancelled.","#S#",DataFileName)
		Exit Sub
	End If
	
	Dim ScrSelText
	Dim ScrSelDefault
	Dim ScrSelCount
	
	GetScrSelData DataArray,ScrSelText,ScrSelDefault,ScrSelCount
	
	Dim OutFileOption

	OutFileOption = CInt(InputBox(ScrSelText&Chr(10),"Choose output script type",ScrSelDefault))

	If Not (1 <= OutFileOption And OutFileOption <= ScrSelCount) Then
		MsgBox "Invalid option. Operation cancelled."
		Exit Sub
	End If
	
	CompileOption = CInt(InputBox("Enter a Number:"&Chr(10)&Chr(10)&"1 = Full version with all stats"&Chr(10)&Chr(10)&"2 = Percentage calculations only <- normal for plugins"&Chr(10)&Chr(10)&"3 = Trait trees stats"&Chr(10),"Choose output version",2))-1

	If Not (CompileOption = optCompileFull Or CompileOption = optCompilePercentages Or CompileOption = optCompileTraitTrees) Then
		MsgBox "Invalid option. Operation cancelled."
		Exit Sub
	End If
	
	GetScriptData DataArray,OutFileOption
	
	Dim SDInfoLst

	ReadSDFile InFileName,SDInfoLst
	
	If Not IsEmpty(SDInfoLst) Then
		MsgBox Replace("Found #N# data records.","#N#",CStr(UBound(SDInfoLst)+1))
	End If

	Dim aDefines
	aDefines = ReadDefines(SDInfoLst)
		
	Dim aStatsIndex
	aStatsIndex = CreateStatsIndex(SDInfoLst)

	Dim aBalancedBST
	aBalancedBST = CreateBalancedBST(aStatsIndex)
	
	Dim OutStream
	Set OutStream = CreateObject("ADODB.Stream")
	With OutStream
		.Type = adTypeText
		.CharSet = "us-ascii"
		.LineSeparator = adCRLF
		.Open

		'Init. script text variables
		STV_SN_TEXT = ""
		STV_LVL_TEXT = ""
		STV_LSTART_TEXT = ""
		STV_LEND_TEXT = ""
		STV_CALC_TEXT = ""
		STV_DATA_TEXT = ""
		STV_NODEID_TEXT = ""
		STV_CHILDID_TEXT = ""

		WriteSText OutStream,STextStart,""

		Dim iNodeIndex
		iNodeIndex = LBound(aBalancedBST)	'Head node of the tree is first in the list

		If IsEmpty(STextSNSearchSubResult) Then
			WriteScrStatsNode OutStream,SDInfoLst,aDefines,aBalancedBST,iNodeIndex,"",1,-1,Nothing
		Else
			WriteSText OutStream,STextMainStart,""

			Dim aMaxDepthNodes
			Dim iMaxDepth: iMaxDepth = GetHeightBSTnode(aBalancedBST,0)-8
			If iMaxDepth < 1 Then
				iMaxDepth = 1
			End If

			WriteScrStatsNode OutStream,SDInfoLst,aDefines,aBalancedBST,iNodeIndex,"",1,iMaxDepth,aMaxDepthNodes

			WriteSText OutStream,STextMainEnd,""

			If Not IsEmpty(aMaxDepthNodes) Then
				Dim oldSTV_NODEID_TEXT: oldSTV_NODEID_TEXT = STV_NODEID_TEXT
				For nSubNode = LBound(aMaxDepthNodes) To UBound(aMaxDepthNodes)
					STV_NODEID_TEXT = CStr(aMaxDepthNodes(nSubNode))
					WriteSText OutStream,STextSubStart,""

					WriteScrStatsNode OutStream,SDInfoLst,aDefines,aBalancedBST,aMaxDepthNodes(nSubNode),"",1,-1,Nothing				

					WriteSText OutStream,STextSubEnd,""
				Next
				STV_NODEID_TEXT = oldSTV_NODEID_TEXT
			End If
			
		End If

		WriteSText OutStream,STextEnd,""

		.SaveToFile OutFileName,adSaveCreateOverWrite
		.Close
	End With
	Set OutStream = Nothing

	MsgBox Replace(Replace("Compilation of #S1# to #S2# completed.","#S1#",InFileName),"#S2#",OutFileName)
	
End Sub

Function ReadDataFile(ByVal theDataFileName, ByRef theDataArray)

	Dim Result
	Result = True

	Dim DataStream
	Set DataStream = CreateObject("ADODB.Stream")
	With DataStream
		.Type = adTypeText
		.CharSet = "UTF-8"
		.LineSeparator = adLF
		.Open
		.LoadFromFile theDataFileName

		Dim RowText

		Do Until .EOS
			RowText = .ReadText(adReadLine)

			RowText = Replace(RowText,Chr(10),"")
			RowText = Replace(RowText,Chr(13),"")

			If IsEmpty(theDataArray) Then
				ReDim theDataArray(0)
			Else
				ReDim Preserve theDataArray(UBound(theDataArray)+1)
			End If
			theDataArray(UBound(theDataArray)) = RowText
		Loop

		.Close
	End With
	Set DataStream = Nothing

	If IsEmpty(theDataArray) Then
		Result = False
	End If
	
	ReadDataFile = Result
	
End Function

Sub	GetScrSelData(ByVal theDataArray, ByRef theScrSelText, ByRef theScrSelDefault, ByRef theScrSelCount)

	Dim SelText
	SelText = "Enter a Number:"

	Dim SelCount
	SelCount = 0
	
	Dim I
	I = LBound(theDataArray)
	Dim MaxI
	MaxI = UBound(theDataArray)
	
	Dim ScrTextLen
	
	'default script number
	theScrSelDefault = CInt(theDataArray(I))
	I = I+1
	
	Do Until MaxI-I < 18
		'script description
		SelCount = SelCount+1
		SelText = SelText & Chr(10) & Chr(10) & CStr(SelCount) & " = " & theDataArray(I)
		I = I+1

		'outfilename
		I = I+1

		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script start text
		I = I+ScrTextLen

		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script main start text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script main end text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script sub start text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script sub end text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search sub result text
		I = I+ScrTextLen

		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script end text
		I = I+ScrTextLen

		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search condition start smaller text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search condition smaller text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search condition start equal text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search condition equal text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search condition start greater text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search condition greater text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search alternative text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search end text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search result text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search result text with DATA
		I = I+ScrTextLen

		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Sequential Level Search condition start text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Sequential Level Search condition text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Sequential Level Search alternative text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Sequential Level Search end text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Sequential Level Search result text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Sequential Level Search result text with DATA
		I = I+ScrTextLen
		
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Interval Level Search condition start text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Interval Level Search condition text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Interval Level Search alternative text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Interval Level Search end text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Interval Level Search result text
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Interval Level Search result text with DATA
		I = I+ScrTextLen
		
		'script Define C text
		I = I+1
		'script Define L text
		I = I+1
		'script Define N text
		I = I+1
		'script Define PUNDEF text
		I = I+1
		'script Define PNULL text
		I = I+1
		'script Define SN text
		I = I+1

		'script Array text
		I = I+1
		'script Define NUM text
		I = I+1
	Loop
	
	theScrSelText = SelText
	theScrSelCount = SelCount
	
End Sub

Sub	GetScriptData(ByVal theDataArray, ByVal theOutFileOption)

	Dim ScriptCount
	ScriptCount = 0
	
	Dim I
	I = LBound(theDataArray)
	Dim MaxI
	MaxI = UBound(theDataArray)
	
	Dim ScrTextLen
	
	'default script number
	I = I+1
	
	Do Until MaxI-I < 18
		ScriptCount = ScriptCount+1

		'script description
		If ScriptCount = theOutFileOption Then
			ScriptDescr = theDataArray(I)
		End If
		I = I+1

		'outfilename
		If ScriptCount = theOutFileOption Then
			OutFileName = theDataArray(I)
		End If
		I = I+1

		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script start text
		If ScriptCount = theOutFileOption Then
			STextStart = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script main start text
		If ScriptCount = theOutFileOption Then
			STextMainStart = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script main end text
		If ScriptCount = theOutFileOption Then
			STextMainEnd = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script sub start text
		If ScriptCount = theOutFileOption Then
			STextSubStart = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script sub end text
		If ScriptCount = theOutFileOption Then
			STextSubEnd = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search sub result text
		If ScriptCount = theOutFileOption Then
			STextSNSearchSubResult = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen

		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script end text
		If ScriptCount = theOutFileOption Then
			STextEnd = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen

		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search condition start smaller text
		If ScriptCount = theOutFileOption Then
			STextSNSearchCondStartSm = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search condition smaller text
		If ScriptCount = theOutFileOption Then
			STextSNSearchCondSm = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search condition start equal text
		If ScriptCount = theOutFileOption Then
			STextSNSearchCondStartEq = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search condition equal text
		If ScriptCount = theOutFileOption Then
			STextSNSearchCondEq = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search condition start greater text
		If ScriptCount = theOutFileOption Then
			STextSNSearchCondStartGr = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search condition greater text
		If ScriptCount = theOutFileOption Then
			STextSNSearchCondGr = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search alternative text
		If ScriptCount = theOutFileOption Then
			STextSNSearchAlternative = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search end text
		If ScriptCount = theOutFileOption Then
			STextSNSearchEnd = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search result text
		If ScriptCount = theOutFileOption Then
			STextSNSearchResult = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script SN search result text with DATA
		If ScriptCount = theOutFileOption Then
			STextSNSearchResultData = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen

		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Sequential Level Search condition start text
		If ScriptCount = theOutFileOption Then
			STextSeqLSearchCondStart = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Sequential Level Search condition text
		If ScriptCount = theOutFileOption Then
			STextSeqLSearchCond = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Sequential Level Search alternative text
		If ScriptCount = theOutFileOption Then
			STextSeqLSearchAlternative = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Sequential Level Search end text
		If ScriptCount = theOutFileOption Then
			STextSeqLSearchEnd = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Sequential Level Search result text
		If ScriptCount = theOutFileOption Then
			STextSeqLSearchResult = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Sequential Level Search result text with DATA
		If ScriptCount = theOutFileOption Then
			STextSeqLSearchResultData = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Interval Level Search condition start text
		If ScriptCount = theOutFileOption Then
			STextIntLSearchCondStart = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Interval Level Search condition text
		If ScriptCount = theOutFileOption Then
			STextIntLSearchCond = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Interval Level Search alternative text
		If ScriptCount = theOutFileOption Then
			STextIntLSearchAlternative = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Interval Level Search end text
		If ScriptCount = theOutFileOption Then
			STextIntLSearchEnd = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Interval Level Search result text
		If ScriptCount = theOutFileOption Then
			STextIntLSearchResult = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		ScrTextLen = CInt(theDataArray(I))
		I = I+1
		'script Interval Level Search result text with DATA
		If ScriptCount = theOutFileOption Then
			STextIntLSearchResultData = GetScriptText(theDataArray,I,ScrTextLen)
		End If
		I = I+ScrTextLen
		
		'script Define C text
		If ScriptCount = theOutFileOption Then
			STextDefineC = theDataArray(I)
		End If
		I = I+1
		'script Define L text
		If ScriptCount = theOutFileOption Then
			STextDefineL = theDataArray(I)
		End If
		I = I+1
		'script Define N text
		If ScriptCount = theOutFileOption Then
			STextDefineN = theDataArray(I)
		End If
		I = I+1
		'script Define PUNDEF text
		If ScriptCount = theOutFileOption Then
			STextDefinePUNDEF = theDataArray(I)
		End If
		I = I+1
		'script Define PNULL text
		If ScriptCount = theOutFileOption Then
			STextDefinePNULL = theDataArray(I)
		End If
		I = I+1
		'script Define SN text
		If ScriptCount = theOutFileOption Then
			STextDefineSN = theDataArray(I)
		End If
		I = I+1

		'script Array text
		If ScriptCount = theOutFileOption Then
			STextArray = theDataArray(I)
		End If
		I = I+1
		'script Define NUM text
		If ScriptCount = theOutFileOption Then
			STextDefineCastNum = theDataArray(I)
		End If
		I = I+1
	Loop
	
	theScrSelText = SelText
	theScrSelCount = SelCount
	
End Sub

Function GetScriptText(theDataArray,I,ScrTextLen)

	Dim ScriptText
	
	For II = I To I+ScrTextLen-1
		If IsEmpty(ScriptText) Then
			ReDim ScriptText(0)
		Else
			ReDim Preserve ScriptText(UBound(ScriptText)+1)
		End If
		ScriptText(UBound(ScriptText)) = theDataArray(II)
	Next
	
	GetScriptText = ScriptText
	
End Function

Function ReadDefines(theSDInfoLst)

	Dim aDefines

	Dim sStat, sLastStat
	sLastStat = ""

	Redim aDefines(5)
	aDefines(0) = Array("$C",STextDefineC,DFT_TEXT,"")
	aDefines(1) = Array("$L",STextDefineL,DFT_TEXT,"")
	aDefines(2) = Array("$NUM",STextDefineCastNum,DFT_TEXT,"")
	aDefines(3) = Array("$N",STextDefineN,DFT_TEXT,"")
	aDefines(4) = Array("$PNULL",STextDefinePNULL,DFT_TEXT,"")
	aDefines(5) = Array("$SN",STextDefineSN,DFT_TEXT,"")
	
	For SI = LBound(theSDInfoLst) To UBound(theSDInfoLst)
		If theSDInfoLst(SI)(SD_SCRIPT) = SCRIPT_DEFINE Then
			sStat = UCase(theSDInfoLst(SI)(SD_STAT))
			If sStat <> sLastStat Then
				Redim Preserve aDefines(UBound(aDefines)+1)
				If Left(theSDInfoLst(SI)(SD_P1),1) = "!" And Right(theSDInfoLst(SI)(SD_P1),1) = "!" Then
					aDefines(UBound(aDefines)) = Array(sStat,Mid(theSDInfoLst(SI)(SD_P1),2,Len(theSDInfoLst(SI)(SD_P1))-2),"")
				Else
					aDefines(UBound(aDefines)) = Array(sStat,theSDInfoLst(SI)(SD_P1),DFT_EXPR,theSDInfoLst(SI)(SD_RNDDEC))
				End If
				sLastStat = sStat
			End If
		End If
	Next

	Dim temp

	For I = UBound(aDefines)-1 To LBound(aDefines) Step -1
		For J = 0 to I
			If Len(aDefines(J)(DF_DEF)) < Len(aDefines(J+1)(DF_DEF)) Then
				temp = aDefines(J+1)
				aDefines(J+1) = aDefines(J)
				aDefines(J) = temp
			End If
		Next
	Next 
	
	EvalDefines aDefines
	
	ReadDefines = aDefines

End Function

Sub EvalDefines(ByRef theDefines)

	Dim bReprocess: bProcess = True
	Dim DI

	While bProcess
		bProcess = False
		For DI = LBound(theDefines) To UBound(theDefines)
			If theDefines(DI)(DF_TYPE) = DFT_EXPR Then
				If ProcessDefineRefs(theDefines(DI)(DF_REPL),theDefines) Then
					If theDefines(DI)(DF_DECIMALS) = "" Then
						theDefines(DI)(DF_REPL) = CStr(Eval(theDefines(DI)(DF_REPL)))
					Else
						theDefines(DI)(DF_REPL) = CStr(RoundDbl(Eval(theDefines(DI)(DF_REPL)),CInt(theDefines(DI)(DF_DECIMALS))))
					End If
					theDefines(DI)(DF_TYPE) = DFT_TEXT
					theDefines(DI)(DF_DECIMALS) = ""
				Else
					bProcess = True
				End If
			End If
		Next
	Wend

End Sub

Function ProcessDefineRefs(ByRef theDefineReplText, ByVal theDefines)

	Dim sProcessedText: sProcessedText = theDefineReplText
	Dim nLenProcessedText: nLenProcessedText = Len(sProcessedText)

	Dim sStartToken: sStartToken = "$"
	Dim nLenStartToken: nLenStartToken = Len(sStartToken)

	Dim bResult: bResult = True

	Dim nSearch
	Dim RI
	Dim sDefName
	Dim nLenDefName
	Dim cDefChar

	Dim sDefReplText
	Dim nLenDefReplText

	For nSearch = 1 To nLenProcessedText
		If Mid(sProcessedText,nSearch,nLenStartToken) = sStartToken Then
			sDefName = ""
			For RI = nSearch+nLenStartToken To nLenProcessedText
				cDefChar = Mid(sProcessedText,RI,1)
				If ("A" <= cDefChar And cDefChar <= "Z") Or ("a" <= cDefChar And cDefChar <= "z") Or ("0" <= cDefChar And cDefChar <= "9") Or cDefChar = "_" Then
					sDefName = sDefName+cDefChar
				Else
					Exit For	
				End If
			Next
			nLenDefName = RI-(nSearch+nLenStartToken)
			If nLenDefName > 0 Then
				If GetDefineReplText(sDefName,theDefines,sDefReplText) Then
					nLenDefReplText = Len(sDefReplText)
					sProcessedText = Left(sProcessedText,nSearch-1)+sDefReplText+Right(sProcessedText,nLenProcessedText-(nSearch-1)-(nLenStartToken+nLenDefName))
					nLenProcessedText = nLenProcessedText+nLenDefReplText-(nLenStartToken+nLenDefName)
					nSearch = (nSearch-1)+nLenDefReplText
				Else
					bResult = False
				End If
			End If
		End If
	Next

	theDefineReplText = sProcessedText
	
	ProcessDefineRefs = bResult

End Function

Function GetDefineReplText(ByVal theDefName, ByVal theDefines, ByRef theDefReplText)

	Dim bResult: bResult = False
	Dim sSearchDefine: sSearchDefine = "$"+UCase(theDefName)
	Dim DI

	For DI = LBound(theDefines) To UBound(theDefines)
		If theDefines(DI)(DF_DEF) = sSearchDefine Then
			If theDefines(DI)(DF_TYPE) = DFT_TEXT Then
				theDefReplText = theDefines(DI)(DF_REPL)
				bResult = True
			End If
			Exit For
		End If
	Next 

	GetDefineReplText = bResult

End Function

Function ReplaceDefines(theText, theDefines)

	Dim sNewText
	sNewText = theText

	Dim sSearchText
	sSearchText = UCase(theText)

	Dim SDefine
	Dim sRepl
	
	Dim nSearch
	
	For DI = LBound(theDefines) To UBound(theDefines)
		sDefine = theDefines(DI)(DF_DEF)
		sRepl = theDefines(DI)(DF_REPL)
		If UCase(sDefine) <> UCase(sRepl) Then
			nSearch = InStr(sSearchText,sDefine)
			While nSearch > 0
				sNewText = Left(sNewText,nSearch-1)+sRepl+Right(sNewText,Len(sSearchText)-nSearch+1-Len(sDefine))
				sSearchText = Left(sSearchText,nSearch-1)+UCase(sRepl)+Right(sSearchText,Len(sSearchText)-nSearch+1-Len(sDefine))
				nSearch = InStr(sSearchText,sDefine)
			Wend
		End If
	Next
	
	ReplaceDefines = sNewText

End Function

Sub WriteSText(theOutStream,theSText,theIndent)

	If VarType(theSText) <> 8204 Then
		Exit Sub
	End If

	With theOutStream
		For I = LBound(theSText) To UBound(theSText)
			.WriteText theIndent & _
				Replace(Replace(Replace(Replace(Replace(Replace(Replace(Replace( _
				theSText(I), _
				STV_SN, STV_SN_TEXT), _
				STV_LVL, STV_LVL_TEXT), _
				STV_LSTART, STV_LSTART_TEXT), _
				STV_LEND, STV_LEND_TEXT), _
				STV_CALC, STV_CALC_TEXT), _
				STV_DATA, STV_DATA_TEXT), _
				STV_NODEID, STV_NODEID_TEXT), _
				STV_CHILDID, STV_CHILDID_TEXT), _
				adWriteLine
		Next
	End With
	
End Sub

Function ReplSText(theSText,theSearch,theRepl)

	Dim NewSText: NewSText = theSText

	For I = LBound(NewSText) To UBound(NewSText)
		NewSText(I) = Replace(NewSText(I),theSearch,theRepl)
	Next

	ReplSText = NewSText
	
End Function

Function NumFloatSText(theSText)

	Dim NewSText: NewSText = theSText

	For I = LBound(NewSText) To UBound(NewSText)
		NewSText(I) = NumFloatText(NewSText(I))
	Next

	NumFloatSText = NewSText

End Function

Function NumFloatText(theText)

	Dim NewText: NewText = ""
	Dim nPos: nPos = 1
	Dim nLen: nLen = Len(theText)
	Dim sChar
	Dim sAlpha: sAlpha = ""
	Dim sNum: sNum = ""
	dim sOther: sOther = ""
	
	While nPos <= nLen
		sChar = Mid(theText,nPos,1)
		If IsAlpha(sChar) Then
			NewText = NewText+sNum
			sNum = ""
			NewText = NewText+sOther
			sOther = ""
			sAlpha = sAlpha+sChar
		ElseIf IsNum(sChar) Then
			NewText = NewText+sAlpha
			sAlpha = ""
			NewText = NewText+sOther
			sOther = ""
			sNum = sNum+sChar
		Else
			NewText = NewText+sAlpha
			sAlpha = ""
			If sNum <> "" And (NewText = "" Or Not IsAlpha(Right(NewText,1))) Then
				'check num which is between non alpha and non alpha or <start> and non alpha
				If InStr(sNum,".") = 0 Then
					'no . so add
					sNum = sNum+".0"
				End If
			End If
			NewText = NewText+sNum
			sNum = ""
			sOther = sOther+sChar
		End If
		nPos = nPos+1
	Wend

	NewText = NewText+sAlpha
	sAlpha = ""
	If sNum <> "" And (NewText = "" Or Not IsAlpha(Right(NewText,1))) Then
		'check num which is between non alpha and <end> or <start> and <end>
		If InStr(sNum,".") = 0 Then
			'no . so add
			sNum = sNum+".0"
		End If
	End If
	NewText = NewText+sNum
	sNum = ""
	NewText = NewText+sOther
	sOther = ""
	
	NumFloatText = NewText

End Function

Function IsAlpha(sChar)

	IsAlpha = (("A" <= sChar And sChar <= "Z") Or ("a" <= sChar And sChar <= "z"))

End Function

Function IsNum(sChar)

	IsNum = (("0" <= sChar And sChar <= "9") Or sChar = ".")

End Function

Sub WriteScrStatsNode(theOutStream,theSDInfoLst,theDefines,aBST,iNodeIndex,sIndent,iCurDepth,iMaxDepth,ByRef aMaxDepthNodes)
	
	Dim oldSTV_SN_TEXT: oldSTV_SN_TEXT = STV_SN_TEXT
	Dim oldSTV_CHILDID_TEXT: oldSTV_CHILDID_TEXT = STV_CHILDID_TEXT
	Dim oldSTV_CALC_TEXT: oldSTV_CALC_TEXT = STV_CALC_TEXT

	With theOutStream
	
		Dim sStatName
		sStatName = aBST(iNodeIndex)(BST_KEY)
		STV_SN_TEXT = sStatName
		
		Dim iStatIndex
		iStatIndex = aBST(iNodeIndex)(BST_VALUE)
		
		Dim bIfOpen
		bIfOpen = False
		
		Dim iLeftIndex
		iLeftIndex = aBST(iNodeIndex)(BST_LEFT)
		
		If iLeftIndex <> -1 Then
			STV_CHILDID_TEXT = CStr(iLeftIndex)
			If bIfOpen Then
				WriteSText theOutStream,STextSNSearchCondSm,sIndent
			Else
				WriteSText theOutStream,STextSNSearchCondStartSm,sIndent
				bIfOpen = True
			End If
			If iMaxDepth > 0 Then
				If iCurDepth+1 <= iMaxDepth Then
					WriteScrStatsNode theOutStream,theSDInfoLst,theDefines,aBST,iLeftIndex,sIndent+"	",iCurDepth+1,iMaxDepth,aMaxDepthNodes
				Else
					If IsEmpty(aMaxDepthNodes) Then
						ReDim aMaxDepthNodes(0)
					Else
						ReDim Preserve aMaxDepthNodes(UBound(aMaxDepthNodes)+1)
					End If
					aMaxDepthNodes(UBound(aMaxDepthNodes)) = iLeftIndex
					WriteSText theOutStream,STextSNSearchSubResult,sIndent
				End If
			Else
				WriteScrStatsNode theOutStream,theSDInfoLst,theDefines,aBST,iLeftIndex,sIndent+"	",iCurDepth+1,iMaxDepth,aMaxDepthNodes
			End If
			STV_CHILDID_TEXT = oldSTV_CHILDID_TEXT
		End If
		
		Dim iRightIndex
		iRightIndex = aBST(iNodeIndex)(BST_RIGHT)
		
		If iRightIndex <> -1 Then
			STV_CHILDID_TEXT = CStr(iRightIndex)
			If bIfOpen Then
				WriteSText theOutStream,STextSNSearchCondGr,sIndent
			Else
				WriteSText theOutStream,STextSNSearchCondStartGr,sIndent
				bIfOpen = True
			End If
			If iMaxDepth > 0 Then
				If iCurDepth+1 <= iMaxDepth Then
					WriteScrStatsNode theOutStream,theSDInfoLst,theDefines,aBST,iRightIndex,sIndent+"	",iCurDepth+1,iMaxDepth,aMaxDepthNodes
				Else
					If IsEmpty(aMaxDepthNodes) Then
						ReDim aMaxDepthNodes(0)
					Else
						ReDim Preserve aMaxDepthNodes(UBound(aMaxDepthNodes)+1)
					End If
					aMaxDepthNodes(UBound(aMaxDepthNodes)) = iRightIndex
					WriteSText theOutStream,STextSNSearchSubResult,sIndent
				End If
			Else
				WriteScrStatsNode theOutStream,theSDInfoLst,theDefines,aBST,iRightIndex,sIndent+"	",iCurDepth+1,iMaxDepth,aMaxDepthNodes
			End If
			STV_CHILDID_TEXT = oldSTV_CHILDID_TEXT
		End If

		If iLeftIndex = -1 Or iRightIndex = -1 Then
			If bIfOpen Then
				WriteSText theOutStream,STextSNSearchCondEq,sIndent
			Else
				WriteSText theOutStream,STextSNSearchCondStartEq,sIndent
				bIfOpen = True
			End If
			WriteScrStat theOutStream,sStatName,theSDInfoLst,theDefines,sIndent
			WriteSText theOutStream,STextSNSearchAlternative,sIndent
			If STextDefineCastNum <> "" Then
				STV_CALC_TEXT = "0.0"
			Else
				STV_CALC_TEXT = "0"
			End If
			WriteSText theOutStream,STextSNSearchResult,sIndent
			STV_CALC_TEXT = oldSTV_CALC_TEXT
		ElseIf iLeftIndex <> -1 And iRightIndex <> -1 Then
			WriteSText theOutStream,STextSNSearchAlternative,sIndent
			WriteScrStat theOutStream,sStatName,theSDInfoLst,theDefines,sIndent
		End If

		If bIfOpen Then
			WriteSText theOutStream,STextSNSearchEnd,sIndent
		End If
		
		STV_SN_TEXT = oldSTV_SN_TEXT

	End With

End Sub

Function CreateStatsIndex(theSDInfoLst)

	Dim aStatsIndex

	Dim sStat, sLastStat
	sLastStat = ""

	For SI = LBound(theSDInfoLst) To UBound(theSDInfoLst)
		If theSDInfoLst(SI)(SD_SCRIPT) <> SCRIPT_DEFINE And theSDInfoLst(SI)(SD_SCRIPT) <> SCRIPT_REMARK Then
			sStat = theSDInfoLst(SI)(SD_STAT)
			If sStat <> sLastStat Then
				If sLastStat <> "" Then
					Redim Preserve aStatsIndex(UBound(aStatsIndex)+1)
					aStatsIndex(UBound(aStatsIndex)) = Array(sStat,SI)
				Else
					aStatsIndex = Array(Array(sStat,SI))
				End If
				sLastStat = sStat
			End If
		End If
	Next

	MsgBox Replace("Number of stats: #N#","#N#",CStr(UBound(aStatsIndex)+1))

	CreateStatsIndex = aStatsIndex

End Function

Function CreateBalancedBST(aStatsIndex)

	Dim iLowIndex
	iLowIndex = LBound(aStatsIndex)
	
	Dim iHighIndex
	iHighIndex = UBound(aStatsIndex)

	Dim iStatIndex
	iStatIndex = Int((iLowIndex+(iHighIndex-iLowIndex)/2))

	Dim aBalancedBST
	aBalancedBST = Array(Array(-1,-1,-1,-1))
	
	Dim iNodeIndex
	iNodeIndex = UBound(aBalancedBST)

	aBalancedBST(iNodeIndex)(BST_KEY) = aStatsIndex(iStatIndex)(0)
	aBalancedBST(iNodeIndex)(BST_VALUE) = aStatsIndex(iStatIndex)(1)
	If iStatIndex-1 >= iLowIndex Then
		aBalancedBST(iNodeIndex)(BST_LEFT) = AddBSTnode(aBalancedBST,aStatsIndex,iLowIndex,iStatIndex-1)
	End If
	If iStatIndex+1 <= iHighIndex Then
		aBalancedBST(iNodeIndex)(BST_RIGHT) = AddBSTnode(aBalancedBST,aStatsIndex,iStatIndex+1,iHighIndex)
	End If

	CreateBalancedBST = aBalancedBST
	
	MsgBox Replace("Height of Binary Search Tree: #N#","#N#",GetHeightBSTnode(aBalancedBST,0))
		
End Function

Function AddBSTnode(ByRef aBST, ByRef aStatsIndex, ByVal iLowIndex, ByVal iHighIndex)

	Dim iStatIndex
	iStatIndex = Int((iLowIndex+(iHighIndex-iLowIndex)/2))
	
	Redim Preserve aBST(UBound(aBST)+1)
	aBST(UBound(aBST)) = Array(-1,-1,-1,-1)

	Dim iNodeIndex
	iNodeIndex = UBound(aBST)

	aBST(iNodeIndex)(BST_KEY) = aStatsIndex(iStatIndex)(0)
	aBST(iNodeIndex)(BST_VALUE) = aStatsIndex(iStatIndex)(1)
	If iStatIndex-1 >= iLowIndex Then
		aBST(iNodeIndex)(BST_LEFT) = AddBSTnode(aBST,aStatsIndex,iLowIndex,iStatIndex-1)
	End If
	If iStatIndex+1 <= iHighIndex Then
		aBST(iNodeIndex)(BST_RIGHT) = AddBSTnode(aBST,aStatsIndex,iStatIndex+1,iHighIndex)
	End If
	
	AddBSTnode = iNodeIndex
	
End Function

Function GetHeightBSTnode(ByRef aBST, ByVal iStatIndex)

	Dim iLeftIndex
	iLeftIndex = aBST(iStatIndex)(BST_LEFT)
	Dim iLeftHeight
	iLeftHeight = 0
	If iLeftIndex <> -1 Then
		iLeftHeight = GetHeightBSTnode(aBST,iLeftIndex)
	End If

	Dim iRightIndex
	iRightIndex = aBST(iStatIndex)(BST_RIGHT)
	Dim iRightHeight
	iRightHeight = 0
	If iRightIndex <> -1 Then
		iRightHeight = GetHeightBSTnode(aBST,iRightIndex)
	End If

	If iLeftHeight >= iRightHeight Then
		GetHeightBSTnode = iLeftHeight+1
	Else
		GetHeightBSTnode = iRightHeight+1
	End If
	
End Function

Sub WriteScrStat(theOutStream,theStat,theSDInfoLst,theDefines,sIndent)

	Dim oldSTV_LVL_TEXT: oldSTV_LVL_TEXT = STV_LVL_TEXT
	Dim oldSTV_LSTART: oldSTV_LSTART_TEXT = STV_LSTART_TEXT
	Dim oldSTV_LEND: oldSTV_LEND_TEXT = STV_LEND_TEXT
	Dim oldSTV_CALC_TEXT: oldSTV_CALC_TEXT = STV_CALC_TEXT
	Dim oldSTV_DATA_TEXT: oldSTV_DATA_TEXT = STV_DATA_TEXT

	With theOutStream

		Dim StatPos
		StatPos = -1
		
		For SI = LBound(theSDInfoLst) To UBound(theSDInfoLst)
			If theSDInfoLst(SI)(SD_STAT) = theStat Then
				StatPos = SI
				Exit For
			End If
		Next

		If StatPos >= 0 Then
			Dim Build
			Dim Data

			Dim bIfWithoutElse: bIfWithoutElse = False

			For SI = StatPos To UBound(theSDInfoLst)
				If theSDInfoLst(SI)(SD_STAT) <> theStat Then
					Exit For
				End If
				
				STV_LVL_TEXT = theSDInfoLst(SI)(SD_LEND)
				STV_LSTART_TEXT = theSDInfoLst(SI)(SD_LSTART)
				STV_LEND_TEXT = theSDInfoLst(SI)(SD_LEND)
				
				For FI = LBound(theSDInfoLst(SI)) To UBound(theSDInfoLst(SI))
					If FI <> SD_STAT Then
						theSDInfoLst(SI)(FI) = ReplaceDefines(theSDInfoLst(SI)(FI),theDefines)
					End If
				Next
				
				If theSDInfoLst(SI)(SD_TYPE) <> "" And theSDInfoLst(SI)(SD_LEND) <> "" And SI = StatPos Then
					If theSDInfoLst(SI)(SD_SCRIPT) = SCRIPT_SEQUENTIAL Then
						WriteSText theOutStream,STextSeqLSearchCondStart,sIndent
					ElseIf theSDInfoLst(SI)(SD_SCRIPT) = SCRIPT_INTERVAL Then
						WriteSText theOutStream,STextIntLSearchCondStart,sIndent
					End If
					bIfWithoutElse = True
				ElseIf theSDInfoLst(SI)(SD_TYPE) <> "" And theSDInfoLst(SI)(SD_LEND) <> "" Then
					If theSDInfoLst(SI)(SD_SCRIPT) = SCRIPT_SEQUENTIAL Then
						WriteSText theOutStream,STextSeqLSearchCond,sIndent
					ElseIf theSDInfoLst(SI)(SD_SCRIPT) = SCRIPT_INTERVAL Then
						WriteSText theOutStream,STextIntLSearchCond,sIndent
					End If
					bIfWithoutElse = True
				ElseIf theSDInfoLst(SI)(SD_TYPE) <> "" And ((theSDInfoLst(SI)(SD_SCRIPT) = SCRIPT_SEQUENTIAL And theSDInfoLst(SI)(SD_LSTART) <> "") Or (theSDInfoLst(SI)(SD_SCRIPT) = SCRIPT_INTERVAL And theSDInfoLst(SI)(SD_LSTART) = "" And theSDInfoLst(SI)(SD_LEND) = "")) Then
					If theSDInfoLst(SI)(SD_SCRIPT) = SCRIPT_SEQUENTIAL Then
						WriteSText theOutStream,STextSeqLSearchAlternative,sIndent
					ElseIf theSDInfoLst(SI)(SD_SCRIPT) = SCRIPT_INTERVAL Then
						WriteSText theOutStream,STextIntLSearchAlternative,sIndent
					End If
					bIfWithoutElse = False
				End If

				Build = ""
				Data = ""

				If theSDInfoLst(SI)(SD_TYPE) = "A" Then
					Build = theSDInfoLst(SI)(SD_P1)
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "C" Then
					Build = theSDInfoLst(SI)(SD_P1)
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "D" Then
					Build = "DataTableValue("+STextArray
					Data = theSDInfoLst(SI)(SD_P1)
					Dim DI
					For DI = SI+1 To UBound(theSDInfoLst)
						If theSDInfoLst(DI)(SD_STAT) <> theStat Or theSDInfoLst(DI)(SD_TYPE) <> "" Then
							Exit For
						End If
						Data = Data+","+theSDInfoLst(DI)(SD_P1)
					Next
					If theSDInfoLst(SI)(SD_LSTART) <> "" And theSDInfoLst(SI)(SD_LSTART) <> "1" Then
						Build = Build+","+STextDefineL+"-"+CStr(theSDInfoLst(SI)(SD_LSTART)-1)+")"
					Else
						Build = Build+","+STextDefineL+")"
					End If
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "E" Then
					If theSDInfoLst(SI)(SD_LSTART) <> "" Then
						Build = "ExpFmod("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_LSTART)+","+theSDInfoLst(SI)(SD_P2)+","+STextDefineL
					Else
						Build = "ExpFmod("+theSDInfoLst(SI)(SD_P1)+",1,"+theSDInfoLst(SI)(SD_P2)+","+STextDefineL
					End If
					If theSDInfoLst(SI)(SD_P3) <> "" Then
						Build = Build+","+theSDInfoLst(SI)(SD_P3)
					Else
						Build = Build+STextDefinePUNDEF
					End If
					If theSDInfoLst(SI)(SD_P4) <> "" Then
						Build = Build+","+theSDInfoLst(SI)(SD_P4)+")"
					Else
						Build = Build+STextDefinePNULL+")"
					End If
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "L" Then
					If InStr(theSDInfoLst(SI)(SD_P1),"/") Or InStr(theSDInfoLst(SI)(SD_P1),"+") Or InStr(theSDInfoLst(SI)(SD_P1),"-") Then
						Build = "("+theSDInfoLst(SI)(SD_P1)+")*"+STextDefineL
					ElseIf theSDInfoLst(SI)(SD_P1) = "1" Then
						Build = STextDefineL
					Else
						Build = theSDInfoLst(SI)(SD_P1)+"*"+STextDefineL
					End If
					If theSDInfoLst(SI)(SD_P2) <> "" Then
						Build = Build+"+"+theSDInfoLst(SI)(SD_P2)
					End If
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "M" Then
					If theSDInfoLst(SI)(SD_P2) <> theSDInfoLst(SI)(SD_P3) Then
						Build = "LinFmod(1,"
						If InStr(theSDInfoLst(SI)(SD_P2),"/") Or InStr(theSDInfoLst(SI)(SD_P2),"+") Or InStr(theSDInfoLst(SI)(SD_P2),"-") Then
							Build = Build+"("+theSDInfoLst(SI)(SD_P2)+")*"
						ElseIf theSDInfoLst(SI)(SD_P2) <> "1" Then
							Build = Build+theSDInfoLst(SI)(SD_P2)+"*"
						End If
						Build = Build+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P1)+""","+theSDInfoLst(SI)(SD_P4)+","+STextDefineN+"),"
						If InStr(theSDInfoLst(SI)(SD_P3),"/") Or InStr(theSDInfoLst(SI)(SD_P3),"+") Or InStr(theSDInfoLst(SI)(SD_P3),"-") Then
							Build = Build+"("+theSDInfoLst(SI)(SD_P3)+")*"
						ElseIf theSDInfoLst(SI)(SD_P3) <> "1" Then
							Build = Build+theSDInfoLst(SI)(SD_P3)+"*"
						End If
						Build = Build+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P1)+""","+theSDInfoLst(SI)(SD_P5)+","+STextDefineN+"),"
						Build = Build+theSDInfoLst(SI)(SD_P4)+","+theSDInfoLst(SI)(SD_P5)+","+STextDefineL
						Build = Build+STextDefinePNULL
						Build = Build+")/"+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P1)+""","+STextDefineL+","+STextDefineN+")"
					Else
						Build = theSDInfoLst(SI)(SD_P2)
					End If
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "P" Then
					Build = "CalcPercAB("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_P2)+","+theSDInfoLst(SI)(SD_P3)+","+STextDefineN+")"
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "R" Then
					Build = "CalcRatAB("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_P2)+","+theSDInfoLst(SI)(SD_P3)+","+STextDefineN+")"
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "S" Then
					'P1 = PntMP
					'P2 = Progression
					'P3 = Progression Base
					'P4 = Progression Adjustment
					Build = "LinFmod(1,"
					Build = Build+"LotroDbl("+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P1)+""","+STextDefineL+STextDefinePNULL+")*"+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P2)+"VPL"","+STextDefineL+","+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P3)+""","+STextDefineL+STextDefinePNULL+"))*"
					If 	theSDInfoLst(SI)(SD_P4) <> "" Then
						Build = Build+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P4)+""","+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P2)+"LPL"","+STextDefineL+STextDefinePNULL+")"+STextDefinePNULL+")*"
					End If
					Build = Build+STextDefineN+"),"
					Build = Build+"LotroDbl("+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P1)+""","+STextDefineL+STextDefinePNULL+")*"+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P2)+"VPH"","+STextDefineL+","+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P3)+""","+STextDefineL+STextDefinePNULL+"))*"
					If 	theSDInfoLst(SI)(SD_P4) <> "" Then
						Build = Build+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P4)+""","+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P2)+"LPH"","+STextDefineL+STextDefinePNULL+")"+STextDefinePNULL+")*"
					End If
					Build = Build+STextDefineN+"),"
					Build = Build+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P2)+"LPL"","+STextDefineL+STextDefinePNULL+"),"
					Build = Build+STextDefineCastNum+"CalcStat("""+theSDInfoLst(SI)(SD_P2)+"LPH"","+STextDefineL+STextDefinePNULL+"),"
					Build = Build+STextDefineL+STextDefinePNULL+")"
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "T" Then
					If theSDInfoLst(SI)(SD_P6) <> "" Then
						Build = "LinFmod("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_P2)+","+theSDInfoLst(SI)(SD_P3)+","+theSDInfoLst(SI)(SD_P4)+","+theSDInfoLst(SI)(SD_P5)+","+STextDefineL+","+theSDInfoLst(SI)(SD_P6)+")"
					Else
						Build = "LinFmod("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_P2)+","+theSDInfoLst(SI)(SD_P3)+","+theSDInfoLst(SI)(SD_P4)+","+theSDInfoLst(SI)(SD_P5)+","+STextDefineL+STextDefinePNULL+")"
					End If
				End If

				If Build <> "" Then

					If Ucase(theSDInfoLst(SI)(SD_USEN)) <> "N" And InStr("CDELT",theSDInfoLst(SI)(SD_TYPE)) Then
						If Build = "0" Then
						ElseIf Build = "1" Then
							Build = STextDefineN
						ElseIf InStr("DEFNT",theSDInfoLst(SI)(SD_TYPE)) Then
							Build = Build+"*"+STextDefineN
						ElseIf InStr(Build,"+") Or InStr(Build,"-") Or InStr(Build,"/") Then
							Build = "("+Build+")*"+STextDefineN
						Else
							Build = Build+"*"+STextDefineN
						End If
					End If

					If theSDInfoLst(SI)(SD_RNDTYPE) <> "" Or theSDInfoLst(SI)(SD_RNDDEC) <> "" Then
						If theSDInfoLst(SI)(SD_RNDTYPE) = "" Then
							theSDInfoLst(SI)(SD_RNDTYPE) = RND_NORMAL
						End If
						If theSDInfoLst(SI)(SD_RNDDEC) = "" Then
							theSDInfoLst(SI)(SD_RNDDEC) = "0"
						End If
						If theSDInfoLst(SI)(SD_RNDTYPE) = RND_NORMAL Then
							Build = "RoundDbl("+Build
						ElseIf theSDInfoLst(SI)(SD_RNDTYPE) = RND_UP Then
							Build = "CeilDbl("+Build
						ElseIf theSDInfoLst(SI)(SD_RNDTYPE) = RND_DOWN Then
							Build = "FloorDbl("+Build
						ElseIf theSDInfoLst(SI)(SD_RNDTYPE) = RND_LOTRO Then
							Build = "LotroDbl("+Build
						End If
						If theSDInfoLst(SI)(SD_RNDTYPE) = RND_LOTRO Then
							Build = Build+")"
						Else
							If theSDInfoLst(SI)(SD_RNDDEC) = "0" Then
								Build = Build+STextDefinePNULL+")"
							Else
								Build = Build+","+theSDInfoLst(SI)(SD_RNDDEC)+")"
							End If
						End If
					End If
	
					Build = Replace(Build,"!","""")
					Build = Replace(Build,"|",",")
					Build = Replace(Build,"+-","-")
					Build = Replace(Build,"--","+")
					Build = Replace(Build,",,)",")")
					Build = Replace(Build,",)",")")
					Build = Replace(Build,",undefined)",")")
					Build = ReplStatRefs(Build)
					If STextDefineCastNum <> "" Then
						Build = NumFloatText(Build)
						Data = NumFloatText(Data)
					End If
					
					STV_CALC_TEXT = Build
					STV_DATA_TEXT = Data

					If theSDInfoLst(SI)(SD_LEND) <> "" Or theSDInfoLst(SI)(SD_LSTART) <> "" Or theSDInfoLst(StatPos)(SD_LEND) <> "" Or theSDInfoLst(StatPos)(SD_LSTART) <> "" Then
						If theSDInfoLst(StatPos)(SD_SCRIPT) = SCRIPT_SEQUENTIAL Then
							If Data <> "" Then
								WriteSText theOutStream,STextSeqLSearchResultData,sIndent
							Else
								WriteSText theOutStream,STextSeqLSearchResult,sIndent
							End If
						ElseIf theSDInfoLst(StatPos)(SD_SCRIPT) = SCRIPT_INTERVAL Then
							If Data <> "" Then
								WriteSText theOutStream,STextIntLSearchResultData,sIndent
							Else
								WriteSText theOutStream,STextIntLSearchResult,sIndent
							End If
						End If
					Else
						If Data <> "" Then
							WriteSText theOutStream,STextSNSearchResultData,sIndent
						Else
							WriteSText theOutStream,STextSNSearchResult,sIndent
						End If
					End If

				End If
			Next	

			If bIfWithoutElse Then
				Build = "0"
				If STextCastNum <> "" Then
					Build = NumFloatText(Build)
				End If
				STV_CALC_TEXT = Build
				STV_DATA_TEXT = ""
				If theSDInfoLst(StatPos)(SD_SCRIPT) = SCRIPT_SEQUENTIAL Then
					WriteSText theOutStream,STextSeqLSearchAlternative,sIndent
					WriteSText theOutStream,STextSeqLSearchResult,sIndent
				ElseIf theSDInfoLst(StatPos)(SD_SCRIPT) = SCRIPT_INTERVAL Then
					WriteSText theOutStream,STextIntLSearchAlternative,sIndent
					WriteSText theOutStream,STextIntLSearchResult,sIndent
				End If
			End If

			If theSDInfoLst(StatPos)(SD_LSTART) <> "" Or theSDInfoLst(StatPos)(SD_LEND) <> "" Then
				If theSDInfoLst(StatPos)(SD_SCRIPT) = SCRIPT_SEQUENTIAL Then
					WriteSText theOutStream,STextSeqLSearchEnd,sIndent
				ElseIf theSDInfoLst(StatPos)(SD_SCRIPT) = SCRIPT_INTERVAL Then
					WriteSText theOutStream,STextIntLSearchEnd,sIndent
				End If
			End If

		End If

	End With

	STV_DATA_TEXT = oldSTV_DATA_TEXT
	STV_CALC_TEXT = oldSTV_CALC_TEXT
	STV_LEND_TEXT = oldSTV_LEND_TEXT
	STV_LSTART_TEXT = oldSTV_LSTART_TEXT
	STV_LVL_TEXT = oldSTV_LVL_TEXT

End Sub

Function ReplStatRefs(ByVal theBuild)

	Dim Result
	Result = theBuild

	Dim nSearch
	Dim BI
	Dim sStartToken, sNumToken, sEncapStartToken, sEncapEndToken
	Dim nEncapOpen
	Dim sStatName
	Dim cStatChar
	Dim sLevel
	Dim sNumber

	sStartToken = "@"
	sNumToken = "#"
	sEncapStartToken = "{"
	sEncapEndToken = "}"

	nSearch = InStr(Result,sStartToken)
	While nSearch > 0
		Result = Left(Result,nSearch-1)+Right(Result,Len(Result)-nSearch+1-Len(sStartToken))

		sStatName = ""
		For BI = nSearch To Len(Result)
			cStatChar = Mid(Result,BI,1)
			If ("A" <= UCase(cStatChar) And UCase(cStatChar) <= "Z") Or ("0" <= UCase(cStatChar) And UCase(cStatChar) <= "9") Then
				sStatName = sStatName+cStatChar
			Else
				Exit For	
			End If
		Next
		For BI = Len(sStatName) To 1 Step -1
			cStatChar = Mid(sStatName,BI,1)
			If "0" <= UCase(cStatChar) And UCase(cStatChar) <= "9" Then
				sStatName = Left(sStatName,BI-1)
			Else
				Exit For
			End If
		Next

		If Len(sStatName) > 0 Then
			Result = Left(Result,nSearch-1)+"CalcStat("""+sStatName+""""+Right(Result,Len(Result)-nSearch+1-Len(sStatName))
			nSearch = nSearch+Len("CalcStat("""+sStatName+"""")

			sLevel = ""
			If Mid(Result,nSearch,Len(sEncapStartToken)) = sEncapStartToken Then
				Result = Left(Result,nSearch-1)+Right(Result,Len(Result)-nSearch+1-Len(sEncapStartToken))
				nEncapOpen = 1
				For BI = nSearch To Len(Result)
					cStatChar = Mid(Result,BI,1)
					If Mid(Result,BI,Len(sEncapStartToken)) = sEncapStartToken Then
						nEncapOpen = nEncapOpen+1
					End If
					If Mid(Result,BI,Len(sEncapEndToken)) = sEncapEndToken Then
						nEncapOpen = nEncapOpen-1
					End If
					If nEncapOpen > 0 Then
						sLevel = sLevel+cStatChar
					Else
						Result = Left(Result,BI-1)+Right(Result,Len(Result)-BI+1-Len(sEncapEndToken))
						Exit For
					End If
				Next
			ElseIf "0" <= Mid(Result,nSearch,1) And Mid(Result,nSearch,1) <= "9" Then
				For BI = nSearch To Len(Result)
					cStatChar = Mid(Result,BI,1)
					If "0" <= cStatChar And cStatChar <= "9" Then
						sLevel = sLevel+cStatChar
					Else
						Exit For
					End If
				Next
			End If
			If sLevel = "" Then
				Result = Left(Result,nSearch-1)+","+STextDefineL+Right(Result,Len(Result)-nSearch+1)
				nSearch = nSearch+Len(","+STextDefineL)
			Else
				Result = Left(Result,nSearch-1)+","+sLevel+Right(Result,Len(Result)-nSearch+1-Len(sLevel))
				nSearch = nSearch+Len(","+sLevel)
			End If

			If Mid(Result,nSearch,Len(sNumToken)) = sNumToken Then
				Result = Left(Result,nSearch-1)+Right(Result,Len(Result)-nSearch+1-Len(sNumToken))

				sNumber = ""
				If Mid(Result,nSearch,Len(sEncapStartToken)) = sEncapStartToken Then
					Result = Left(Result,nSearch-1)+Right(Result,Len(Result)-nSearch+1-Len(sEncapStartToken))
					nEncapOpen = 1
					For BI = nSearch To Len(Result)
						cStatChar = Mid(Result,BI,1)
						If Mid(Result,BI,Len(sEncapStartToken)) = sEncapStartToken Then
							nEncapOpen = nEncapOpen+1
						End If
						If Mid(Result,BI,Len(sEncapEndToken)) = sEncapEndToken Then
							nEncapOpen = nEncapOpen-1
						End If
						If nEncapOpen > 0 Then
							sNumber = sNumber+cStatChar
						Else
							Result = Left(Result,BI-1)+Right(Result,Len(Result)-BI+1-Len(sEncapEndToken))
							Exit For
						End If
					Next
				ElseIf "0" <= Mid(Result,nSearch,1) And Mid(Result,nSearch,1) <= "9" Then
					For BI = nSearch To Len(Result)
						cStatChar = Mid(Result,BI,1)
						If ("0" <= cStatChar And cStatChar <= "9") Or cStatChar = "." Then
							sNumber = sNumber+cStatChar
						Else
							Exit For
						End If
					Next
				End If
				If sNumber = "" Then
					Result = Left(Result,nSearch-1)+","+STextDefineN+")"+Right(Result,Len(Result)-nSearch+1)
					nSearch = nSearch+Len(","+STextDefineN+")")
				Else
					Result = Left(Result,nSearch-1)+","+sNumber+")"+Right(Result,Len(Result)-nSearch+1-Len(sNumber))
					nSearch = nSearch+Len(","+sNumber+")")
				End If
			Else
				Result = Left(Result,nSearch-1)+STextDefinePNULL+")"+Right(Result,Len(Result)-nSearch+1)
				nSearch = nSearch+Len(STextDefinePNULL+")")
			End If

		End If

		nSearch = InStr(Result,sStartToken)
	Wend

	ReplStatRefs = Result

End Function

Sub ReadSDFile(ByVal theInFileName, ByRef theSDInfoLst)

	Dim InStream
	Set InStream = CreateObject("ADODB.Stream")
	With InStream
		.Type = adTypeText
		.CharSet = "UTF-8"
		.LineSeparator = adLF
		.Open
		.LoadFromFile theInFileName

		Dim ReadError
		ReadError = False

		Dim RowText
		RowText = ""

		'skip header line
		RowText = .ReadText(adReadLine)

		Do Until .EOS OR ReadError
			RowText = .ReadText(adReadLine)

			RowText = Replace(RowText,Chr(10),"")
			RowText = Replace(RowText,Chr(13),"")

			Dim NewSDInfo
			InitSDInfo NewSDInfo

			For FldI = LBound(NewSDInfo) To UBound(NewSDInfo)
				ReadSDField RowText, NewSDInfo(FldI)
			Next

			If NewSDInfo(SD_COMPF) = "" Then
				NewSDInfo(SD_COMPF) = "0"
			End If
			
			If NewSDInfo(SD_STAT) = "-VERSION" Then
				Select Case CompileOption
					Case optCompileFull
						NewSDInfo(SD_P1) = Replace(NewSDInfo(SD_P1),"v","f")
					Case optCompilePercentages
						NewSDInfo(SD_P1) = Replace(NewSDInfo(SD_P1),"v","p")
					Case optCompileTraitTrees
						NewSDInfo(SD_P1) = Replace(NewSDInfo(SD_P1),"v","t")
				End Select
			End If
			
			If NewSDInfo(SD_STAT) = "" Then
				Break
			ElseIf ((NewSDInfo(SD_SCRIPT) = SCRIPT_DEFINE) Or CompileOption = optCompileFull Or (CInt(NewSDInfo(SD_COMPF)) And (2^(CompileOption-1)))) And ((NewSDInfo(SD_SCRIPT) <> SCRIPT_REMARK)) Then
				If IsEmpty(theSDInfoLst) Then
					ReDim theSDInfoLst(0)
				Else
					ReDim Preserve theSDInfoLst(UBound(theSDInfoLst)+1)
				End If
				theSDInfoLst(UBound(theSDInfoLst)) = NewSDInfo
			End If
		Loop

		.Close
	End With
	Set InStream = Nothing

End Sub

Sub InitSDInfo(ByRef theSDInfo)

	theSDInfo = Split(String(SDFLDCNT-1,","),",",SDFLDCNT)
				
End Sub

Sub ReadSDField(ByRef RowText, ByRef NewSDFld)

	Dim SepPos
	SepPos = InStr(RowText,SDFLDSEP)
	If SepPos > 0 Then
		NewSDFld = RTrim(Mid(RowText,1,SepPos-1))
		RowText = LTrim(Mid(RowText,SepPos+1,Len(RowText)-SepPos))
	Else
		NewSDFld = Rtrim(RowText)
		RowText = ""
	End If

	If Len(NewSDFld) >= 2 Then
		If Mid(NewSDFld,1,1) = SDSTRQUOT AND Mid(NewSDFld,Len(NewSDFld),1) = SDSTRQUOT Then
			NewSDFld = Mid(NewSDFld,2,Len(NewSDFld)-2)
		End If
	End If

End Sub

Function Eval(ByVal Expr)
  Do While HandleParentheses(Expr): Loop

  Dim L, R
  If Spl(Expr, "Or", L, R) Then:   Eval = Eval(L) Or Eval(R):   Exit Function
  If Spl(Expr, "And", L, R) Then:  Eval = Eval(L) And Eval(R):  Exit Function
  If Spl(Expr, ">=", L, R) Then:   Eval = Eval(L) >= Eval(R):   Exit Function
  If Spl(Expr, "<=", L, R) Then:   Eval = Eval(L) <= Eval(R):   Exit Function
  If Spl(Expr, "=", L, R) Then:    Eval = Eval(L) = Eval(R):    Exit Function
  If Spl(Expr, ">", L, R) Then:    Eval = Eval(L) > Eval(R):    Exit Function
  If Spl(Expr, "<", L, R) Then:    Eval = Eval(L) < Eval(R):    Exit Function
  If Spl(Expr, "Like", L, R) Then: Eval = Eval(L) Like Eval(R): Exit Function
  If Spl(Expr, "&", L, R) Then:    Eval = Eval(L) & Eval(R):    Exit Function
  If Spl(Expr, "-", L, R) Then:    Eval = Eval(L) - Eval(R):    Exit Function
  If Spl(Expr, "+", L, R) Then:    Eval = Eval(L) + Eval(R):    Exit Function
  If Spl(Expr, "Mod", L, R) Then:  Eval = Eval(L) Mod Eval(R):  Exit Function
  If Spl(Expr, "\", L, R) Then:    Eval = Eval(L) \ Eval(R):    Exit Function
  If Spl(Expr, "*", L, R) Then:    Eval = Eval(L) * Eval(R):    Exit Function
  If Spl(Expr, "/", L, R) Then:    Eval = Eval(L) / Eval(R):    Exit Function
  If Spl(Expr, "^", L, R) Then:    Eval = Eval(L) ^ Eval(R):    Exit Function
  If Trim(Expr) >= "A" Then:       Eval = Fnc(Expr):            Exit Function
  If Len(Expr) Then:               Eval = IIf(InStr(Expr, "'"), Replace(Trim(Expr), "'", ""), Val(Expr))
End Function

Private Function HandleParentheses(Expr)
  Dim P: P = InStr(Expr, "(")
  If P Then HandleParentheses = True Else Exit Function

  Dim i, C: C = 0
  For i = P To Len(Expr)
    If Mid(Expr, i, 1) = "(" Then C = C + 1
    If Mid(Expr, i, 1) = ")" Then C = C - 1
    If C = 0 Then Exit For
  Next

  Expr = Left(Expr, P - 1) & Str(Eval(Mid(Expr, P + 1, i - P - 1))) & Mid(Expr, i + 1)
End Function

Private Function Spl(Expr, Op, L, R)
  Dim P: P = InStrRev(Expr, Op, -1 , 1)
  If P Then Spl = True Else Exit Function
  If P < InStrRev(Expr, "'") And InStr("*-", Op) Then P = InStrRev(Expr, "'", P) - 1

  R = Mid(Expr, P + Len(Op))
  L = Trim(Left(Expr, IIf(P > 0, P - 1, 0)))

  Dim testthis: testthis = Right(L, 1)
  Select Case testthis
    Case "", "+", "*", "/": Spl = False
    Case "-": R = "-" & R
	Case Else: If testthis >= "A" And testthis <= "z" Then Spl = False
  End Select
End Function

Private Function Fnc(Expr)
  Expr = LCase(Trim(Expr))

  Select Case Left(Expr, 3)
    Case "abs": Fnc = Abs(Val(Mid(Expr, 4)))
    Case "sin": Fnc = Sin(Val(Mid(Expr, 4)))
    Case "cos": Fnc = Cos(Val(Mid(Expr, 4)))
    Case "atn": Fnc = Atn(Val(Mid(Expr, 4)))
    Case "log": Fnc = Log(Val(Mid(Expr, 4)))
    Case "exp": Fnc = Exp(Val(Mid(Expr, 4)))
    'etc...
  End Select
End Function

Private Function IIf(Cond, Value1, Value2)
  If Cond Then IIf = Value1 Else IIf = Value2
End Function

Private Function Str(NumValue)
  Str = CStr(NumValue)
End Function

Private Function Val(StrValue)
  Val = CDbl(StrValue)
End Function

Private Const DblCalcDev = 0.00000001

' ****************** Misc. floating point support functions ******************

' Misc. functions for floating point rounding.
' 2nd parameter is number of decimals.

Private Function RoundDbl(ByVal dNum, ByVal vDec)

	If VarType(vDec) = 9 Then
		RoundDbl = Int(dNum+0.5+DblCalcDev)
	ElseIf -DblCalcDev <= vDec And vDec <= DblCalcDev Then
		RoundDbl = Int(dNum+0.5+DblCalcDev)
	Else
		RoundDbl = Int(dNum*10^vDec+0.5+DblCalcDev)/10^vDec
	End If
	
End Function
